import { subDays } from 'date-fns';
import { SplitTest } from './../../components';
import { user_can_check_analytics } from './../../utils/helper';
betterLinksHooks.addFilter('betterLinksIsEnableIndividualAnalytic', 'betterlinks', (isEnable) => {
	return !isEnable;
});
betterLinksHooks.addFilter('betterLinksFetchClicksData', 'betterlinks', (param) => {
	const currentPage = betterLinksQuery.get('page');
	const ID = betterLinksQuery.get('id');
	if (currentPage == 'betterlinks-analytics' && ID) {
		return param + '/individual/' + ID;
	}
	return param;
});

betterLinksHooks.addFilter('betterLinksAnalyticsFilterStartDate', 'betterlinks', (date) => {
	const currentPage = betterLinksQuery.get('page');
	const ID = betterLinksQuery.get('id');
	if (currentPage == 'betterlinks-analytics' && ID) {
		return subDays(new Date(), 365);
	}
	return date;
});

betterLinksHooks.addFilter('isShowAnalyticsMenu', 'betterlinks', () => {
	return !!user_can_check_analytics;
});

betterLinksHooks.addFilter('analyticsInnerChild', 'betterlinks', (content, arg) => {
	if (arg['split-test']) {
		return <SplitTest />;
	}
	return content;
});
