import React from 'react';
import { __ } from '@wordpress/i18n';
import ShareUrl from 'share-url';

const propTypes = {};

const defaultProps = {};

export default class Email extends React.Component {
	constructor(props) {
		super(props);
		this.state = {
			to: '',
			cc: '',
			subject: '',
			body: this.props.targetUrl,
		};
		this.generateURL = this.generateURL.bind(this);
	}

	generateURL() {
		let config = {};
		if (this.state.to) {
			config.to = this.state.to;
		}
		if (this.state.cc) {
			config.cc = this.state.cc;
		}
		if (this.state.subject) {
			config.subject = this.state.subject;
		}
		if (this.state.body) {
			config.body = this.state.body;
		}
		this.props.saveTempValueHandler(ShareUrl.email(config));
	}

	render() {
		return (
			<React.Fragment>
				<div className="btl-modal-utm-builder__form-group-facebook">
					<h4>{__('Email Share Link', 'betterlinks-pro')}</h4>
					<div className="btl-modal-utm-builder__form-group">
						<label htmlFor="to">{__('TO', 'betterlinks-pro')}</label>
						<div id="to">
							<input type="text" value={this.state.to} onChange={(e) => this.setState({ to: e.target.value })} />
						</div>
					</div>
					<div className="btl-modal-utm-builder__form-group">
						<label htmlFor="cc">{__('CC', 'betterlinks-pro')}</label>
						<div id="cc">
							<input type="text" value={this.state.cc} onChange={(e) => this.setState({ cc: e.target.value })} />
						</div>
					</div>
					<div className="btl-modal-utm-builder__form-group">
						<label htmlFor="subject">{__('Subject', 'betterlinks-pro')}</label>
						<div id="subject">
							<input type="text" value={this.state.subject} onChange={(e) => this.setState({ subject: e.target.value })} />
						</div>
					</div>
					<div className="btl-modal-utm-builder__form-group">
						<label htmlFor="body">{__('Body', 'betterlinks-pro')}</label>
						<div id="body">
							<textarea rows="3" value={this.state.body} onChange={(e) => this.setState({ body: e.target.value })} />
						</div>
					</div>
					<div className="btl-modal-utm-builder__form-group">
						<button type="button" onClick={this.generateURL} style={{ width: '100%', height: 35, fontSize: '14px' }}>
							{__('Generate URL', 'betterlinks-pro')}
						</button>
					</div>
				</div>
			</React.Fragment>
		);
	}
}

Email.propTypes = propTypes;
Email.defaultProps = defaultProps;
