import React from 'react';
import queryString from 'query-string';
import ShareUrl from 'share-url';
import { __ } from '@wordpress/i18n';

const propTypes = {};

const defaultProps = {};

export default class Linkedin extends React.Component {
	constructor(props) {
		super(props);
		this.state = {
			url: this.props.targetUrl,
			title: '',
			summary: '',
		};
		this.generateURL = this.generateURL.bind(this);
	}

	generateURL() {
		const parsed = queryString.parseUrl(this.props.targetUrl);
		const url = parsed.query.url ? parsed.query.url : parsed.query.u;
		let config = {
			mini: true,
			url: url ? url : this.props.targetUrl,
			source: 'LinkedIn',
		};
		if (this.state.title) {
			config.title = this.state.title;
		}
		if (this.state.summary) {
			config.summary = this.state.summary;
		}
		this.props.saveTempValueHandler(ShareUrl.linkedin(config));
	}

	render() {
		return (
			<React.Fragment>
				<div className="btl-modal-utm-builder__form-group-linkedin">
					<h4>{__('LinkedIn Share Link', 'betterlinks-pro')}</h4>
					<div className="btl-modal-utm-builder__form-group">
						<label htmlFor="title">{__('Title', 'betterlinks-pro')}</label>
						<div id="title">
							<input type="text" value={this.state.title} onChange={(e) => this.setState({ title: e.target.value })} />
						</div>
					</div>
					<div className="btl-modal-utm-builder__form-group">
						<label htmlFor="summary">{__('Summary', 'betterlinks-pro')}</label>
						<div id="summary">
							<textarea rows="3" value={this.state.summary} onChange={(e) => this.setState({ summary: e.target.value })} />
						</div>
					</div>
					<div className="btl-modal-utm-builder__form-group">
						<button type="button" onClick={this.generateURL} style={{ width: '100%', height: 35, fontSize: '14px' }}>
							{__('Generate URL', 'betterlinks-pro')}
						</button>
					</div>
				</div>
			</React.Fragment>
		);
	}
}

Linkedin.propTypes = propTypes;
Linkedin.defaultProps = defaultProps;
