import React from 'react';
import queryString from 'query-string';
import ShareUrl from 'share-url';
import { __ } from '@wordpress/i18n';

const propTypes = {};

const defaultProps = {};

export default class Pinterest extends React.Component {
	constructor(props) {
		super(props);
		this.state = {
			url: this.props.targetUrl,
			media: '',
			description: '',
		};
		this.generateURL = this.generateURL.bind(this);
	}

	generateURL() {
		const parsed = queryString.parseUrl(this.props.targetUrl);
		const url = parsed.query.url ? parsed.query.url : parsed.query.u;
		let config = {
			url: url ? url : this.props.targetUrl,
		};
		if (this.state.media) {
			config.media = this.state.media;
		}
		if (this.state.description) {
			config.description = this.state.description;
		}
		this.props.saveTempValueHandler(ShareUrl.pinterest(config));
	}

	render() {
		return (
			<React.Fragment>
				<div className="btl-modal-utm-builder__form-group-pinterest">
					<h4>{__('Pinterest Share Link', 'betterlinks-pro')}</h4>
					<div className="btl-modal-utm-builder__form-group">
						<label htmlFor="title">{__('Media URL', 'betterlinks-pro')}</label>
						<div id="title">
							<input type="text" value={this.state.media} onChange={(e) => this.setState({ media: e.target.value })} />
						</div>
					</div>
					<div className="btl-modal-utm-builder__form-group">
						<label htmlFor="description">{__('Description', 'betterlinks-pro')}</label>
						<div id="description">
							<textarea rows="3" value={this.state.description} onChange={(e) => this.setState({ description: e.target.value })} />
						</div>
					</div>
					<div className="btl-modal-utm-builder__form-group">
						<button type="button" onClick={this.generateURL} style={{ width: '100%', height: 35, fontSize: '14px' }}>
							{__('Generate URL', 'betterlinks-pro')}
						</button>
					</div>
				</div>
			</React.Fragment>
		);
	}
}

Pinterest.propTypes = propTypes;
Pinterest.defaultProps = defaultProps;
