import React from 'react';
import queryString from 'query-string';
import ShareUrl from 'share-url';
import { __ } from '@wordpress/i18n';

const propTypes = {};

const defaultProps = {};

export default class Twitter extends React.Component {
	constructor(props) {
		super(props);
		this.state = {
			text: '',
			url: this.props.targetUrl,
			hashtags: '',
			via: '',
			related: '',
		};
		this.generateURL = this.generateURL.bind(this);
	}

	generateURL() {
		const parsed = queryString.parseUrl(this.props.targetUrl);
		const url = parsed.query.url ? parsed.query.url : parsed.query.u;
		let config = {
			url: url ? url : this.props.targetUrl,
		};
		if (this.state.text) {
			config.text = this.state.text;
		}
		if (this.state.hashtags) {
			config.hashtags = this.state.hashtags;
		}
		if (this.state.via) {
			config.via = this.state.via;
		}
		if (this.state.related) {
			config.related = this.state.related;
		}
		this.props.saveTempValueHandler(ShareUrl.twitter(config));
	}

	render() {
		return (
			<React.Fragment>
				<div className="btl-modal-utm-builder__form-group-twitter">
					<h4>{__('Twitter Share Link', 'betterlinks-pro')}</h4>
					<p>{__('Twitter will automatically truncate or shorten links that exceed 32 characters', 'betterlinks-pro')}</p>
					<div className="btl-modal-utm-builder__form-group">
						<label for="utmSource">{__('Share Text', 'betterlinks-pro')}</label>
						<div>
							<input type="text" value={this.state.text} onChange={(e) => this.setState({ text: e.target.value })} />
						</div>
					</div>
					<div className="btl-modal-utm-builder__form-group">
						<label for="utmSource">{__('HashTags', 'betterlinks-pro')}</label>
						<div>
							<input type="text" value={this.state.hashtags} onChange={(e) => this.setState({ hashtags: e.target.value })} />
						</div>
					</div>
					<div className="btl-modal-utm-builder__form-group">
						<label for="utmSource">{__('Via', 'betterlinks-pro')}</label>
						<div>
							<input type="text" value={this.state.via} onChange={(e) => this.setState({ via: e.target.value })} />
						</div>
					</div>
					<div className="btl-modal-utm-builder__form-group">
						<label for="utmSource">{__('Related', 'betterlinks-pro')}</label>
						<div>
							<input type="text" value={this.state.related} onChange={(e) => this.setState({ related: e.target.value })} />
						</div>
					</div>
					<div className="btl-modal-utm-builder__form-group">
						<button type="button" onClick={this.generateURL} style={{ width: '100%', height: 35, fontSize: '14px' }}>
							{__('Generate URL', 'betterlinks-pro')}
						</button>
					</div>
				</div>
			</React.Fragment>
		);
	}
}

Twitter.propTypes = propTypes;
Twitter.defaultProps = defaultProps;
