import React, { useState } from 'react';
import DateFnsUtils from '@date-io/date-fns';
import { DateTimePicker, MuiPickersUtilsProvider } from '@material-ui/pickers';
import { formatDate } from './../../utils/helper';
import PropTypes from 'prop-types';

const propTypes = {};

const defaultProps = {};

export default function DateAndTimePicker({ name, value, setFieldValue }) {
	const [isDisable, setIsDisable] = useState(betterLinksHooks.applyFilters('isDisableLinkFormEditView', false, value));
	const onChangeHandler = (date) => {
		if (name === 'link_date') {
			setFieldValue('link_date', formatDate(date, 'yyyy-mm-dd h:m:s'));
			setFieldValue('link_date_gmt', formatDate(date, 'yyyy-mm-dd h:m:s'));
		} else {
			setFieldValue(name, formatDate(date, 'yyyy-mm-dd h:m:s'));
		}
		setIsDisable(false);
	};
	return (
		<React.Fragment>
			<MuiPickersUtilsProvider utils={DateFnsUtils}>
				<DateTimePicker disablePast={true} inputVariant="outlined" value={value ? value : new Date()} onChange={(date) => onChangeHandler(date)} disabled={isDisable} />
			</MuiPickersUtilsProvider>
		</React.Fragment>
	);
}

DateAndTimePicker.propTypes = propTypes;
DateAndTimePicker.defaultProps = defaultProps;
