import React from 'react';
import { __ } from '@wordpress/i18n';
import PropTypes from 'prop-types';
import { DateAndTimePicker } from '..';

const propTypes = {
	DateAndTimePicker: PropTypes.object,
	values: PropTypes.object,
	setFieldValue: PropTypes.func,
};

const defaultProps = {
	values: {},
};

export default class Expired extends React.Component {
	constructor(props) {
		super(props);
	}
	render() {
		return (
			<React.Fragment>
				<div className="btl-modal-form-group">
					<label className="btl-modal-form-label">{__('Expire', 'betterlinks-pro')}</label>
					<input
						type="checkbox"
						defaultChecked={this.props.values.status}
						onChange={() => this.props.setFieldValue('expire.status', !this.props.values.status)}
						disabled={this.props.disabled}
					/>
				</div>
				{this.props.values.status == true && (
					<>
						<div className="btl-modal-form-group">
							<label className="btl-modal-form-label">{__('Expire After', 'betterlinks-pro')}</label>
							<select onChange={(e) => this.props.setFieldValue('expire.type', e.target.value)} value={this.props.values.type} disabled={this.props.disabled}>
								<option value="date">{__('Date', 'betterlinks-pro')}</option>
								<option value="clicks">{__('Clicks', 'betterlinks-pro')}</option>
							</select>
						</div>
						{this.props.values.type == 'date' ? (
							<div className="btl-modal-form-group">
								<label className="btl-modal-form-label">{__('Date', 'betterlinks-pro')}</label>
								<DateAndTimePicker name={'expire.date'} value={this.props.values.date} setFieldValue={this.props.setFieldValue} />
							</div>
						) : (
							<div className="btl-modal-form-group">
								<label className="btl-modal-form-label">{__('Clicks', 'betterlinks-pro')}</label>
								<input type="text" value={this.props.values.clicks} onChange={(e) => this.props.setFieldValue('expire.clicks', e.target.value)} disabled={this.props.disabled} />
							</div>
						)}
						<div className="btl-modal-form-group">
							<label className="btl-modal-form-label">
								{__('Redirect URL', 'betterlinks-pro')} <br />
								{__('after Expiration', 'betterlinks-pro')}
							</label>
							<input
								type="checkbox"
								defaultChecked={this.props.values.redirect_status}
								onChange={() => this.props.setFieldValue('expire.redirect_status', !this.props.values.redirect_status)}
								disabled={this.props.disabled}
							/>
						</div>
						{this.props.values.redirect_status == true && (
							<div className="btl-modal-form-group">
								<label className="btl-modal-form-label">{__('Redirect URL', 'betterlinks-pro')}</label>
								<input
									type="text"
									value={this.props.values.redirect_url}
									onChange={(e) => this.props.setFieldValue('expire.redirect_url', e.target.value)}
									disabled={this.props.disabled}
								/>
							</div>
						)}
					</>
				)}
			</React.Fragment>
		);
	}
}

Expired.propTypes = propTypes;
Expired.defaultProps = defaultProps;
