import React from 'react';
import PropTypes from 'prop-types';
import axios from 'axios';
import { __ } from '@wordpress/i18n';
import { betterlinkspro_nonce, delayStatusChanged } from './../../utils/helper';

const propTypes = {};

const defaultProps = {};

export default class GoogleAnalytics extends React.Component {
	constructor(props) {
		super(props);

		this.state = {
			submitLabel: __('Save Settings', 'betterlinks-pro'),
			is_enable_ga: false,
			ga_tracking_code: '',
		};
		this.handleSubmit = this.handleSubmit.bind(this);
		this.changeSubmitLabel = this.changeSubmitLabel.bind(this);
	}

	changeSubmitLabel(newLabel) {
		this.setState({ submitLabel: newLabel });
	}

	componentDidMount() {
		let form_data = new FormData();
		form_data.append('action', 'betterlinkspro/admin/get_google_analytics');
		form_data.append('security', betterlinkspro_nonce);
		axios.post(ajaxurl, form_data).then(
			(response) => {
				if (response.data) {
					this.setState({ ...response.data.data });
				}
			},
			(error) => {
				console.log(error);
			}
		);
	}

	handleSubmit(e) {
		e.preventDefault();
		delayStatusChanged(__('Saving...', 'betterlinks-pro'), __('Saved!', 'betterlinks-pro'), __('Save Settings', 'betterlinks-pro'), this.changeSubmitLabel);
		let form_data = new FormData();
		form_data.append('action', 'betterlinkspro/admin/google_analytics');
		if (this.state.is_enable_ga) {
			form_data.append('is_enable_ga', this.state.is_enable_ga);
		}
		form_data.append('ga_tracking_code', this.state.ga_tracking_code);
		form_data.append('security', betterlinkspro_nonce);
		axios.post(ajaxurl, form_data).then(
			(response) => {
				// write json links
				axios.post(`${ajaxurl}?action=betterlinks/admin/write_json_links&security=${betterlinkspro_nonce}`).then(
					(response) => {},
					(error) => {
						console.log(error);
					}
				);
			},
			(error) => {
				console.log(error);
			}
		);
	}

	render() {
		return (
			<React.Fragment>
				<div className="btl-tab-inner-divider">
					<div className="btl-tab-panel-inner">
						<div className="btl-googleanalytics-container">
							<form className="form" onSubmit={this.handleSubmit} id="googleAnalytics">
								<div className="btl-role-item btl-form-group">
									<label className="btl-form-label">{__('Enable Google Analytics', 'betterlinks-pro')}</label>
									<div className="link-options__body">
										<label className="btl-checkbox-field">
											<input
												type="checkbox"
												className="btl-check"
												name="is_enable_ga"
												checked={this.state.is_enable_ga == true}
												onChange={() => this.setState({ is_enable_ga: !this.state.is_enable_ga })}
											/>
											<span className="text"></span>
										</label>
									</div>
								</div>
								{this.state.is_enable_ga && (
									<div className="btl-role-item btl-form-group">
										<label className="btl-form-label">{__('Google Analytics Tracking ID', 'betterlinks-pro')}</label>
										<div className="link-options__body">
											<input
												type="text"
												name="ga_tracking_code"
												className="btl-form-control"
												value={this.state.ga_tracking_code}
												onChange={(e) => this.setState({ ga_tracking_code: e.target.value })}
											/>
										</div>
									</div>
								)}
								<button className="button-primary btn-save-settings" type="submit">
									{this.state.submitLabel}
								</button>
							</form>
						</div>
					</div>
				</div>
			</React.Fragment>
		);
	}
}

GoogleAnalytics.propTypes = propTypes;
GoogleAnalytics.defaultProps = defaultProps;
