import React from 'react';
import { __ } from '@wordpress/i18n';
import { Status, DateAndTimePicker, Expired } from '..';
import PropTypes from 'prop-types';

const propTypes = {
	DateAndTimePicker: PropTypes.object,
	values: PropTypes.object,
	setFieldValue: PropTypes.func,
};

const defaultProps = {
	values: {},
};

export default function LinkExtend(props) {
	return (
		<React.Fragment>
			<div className="btl-modal-form-group">
				<label className="btl-modal-form-label">{__('Status', 'betterlinks-pro')}</label>
				<Status
					className="btl-modal-select--full"
					classNamePrefix="btl-react-select"
					id="link_status"
					name="link_status"
					value={props.values.link_status}
					setFieldValue={props.setFieldValue}
					disabled={betterLinksHooks.applyFilters('isDisableLinkFormEditView', false, props.values.ID)}
					isMulti={false}
				/>
			</div>
			{props.values.link_status === 'scheduled' && (
				<div className="btl-modal-form-group">
					<label className="btl-modal-form-label">{__('Date', 'betterlinks-pro')}</label>
					<DateAndTimePicker name="link_date" value={props.values.link_date} setFieldValue={props.setFieldValue} />
				</div>
			)}
			<Expired values={props.values.expire} disabled={betterLinksHooks.applyFilters('isDisableLinkFormEditView', false, props.values.ID)} setFieldValue={props.setFieldValue} />
		</React.Fragment>
	);
}

LinkExtend.propTypes = propTypes;
LinkExtend.defaultProps = defaultProps;
