import React from 'react';
import Select from 'react-select';
import { __ } from '@wordpress/i18n';
import PropTypes from 'prop-types';

const propTypes = {};

const defaultProps = {};

const deviceList = [
	{
		label: __('Any', 'betterlinks-pro'),
		value: 'any',
	},
	{
		label: __('Desktop', 'betterlinks-pro'),
		value: 'desktop',
	},
	{
		label: __('Mobile', 'betterlinks-pro'),
		value: 'mobile',
	},
	{
		label: __('Phone', 'betterlinks-pro'),
		value: 'phone',
	},
	{
		label: __('Tablet', 'betterlinks-pro'),
		value: 'tablet',
	},
];

const osList = [
	{
		label: __('Android', 'betterlinks-pro'),
		value: 'android',
	},
	{
		label: __('IOS', 'betterlinks-pro'),
		value: 'ios',
	},
	{
		label: __('Linux', 'betterlinks-pro'),
		value: 'linux',
	},
	{
		label: __('Mac', 'betterlinks-pro'),
		value: 'mac',
	},
	{
		label: __('Windows', 'betterlinks-pro'),
		value: 'windows',
	},
];

const browserList = [
	{
		label: __('Any', 'betterlinks-pro'),
		value: 'any',
	},
	{
		label: __('Amazon Silk', 'betterlinks-pro'),
		value: 'amazonsilk',
	},
	{
		label: __('Andorid', 'betterlinks-pro'),
		value: 'andorid',
	},
	{
		label: __('Chrome', 'betterlinks-pro'),
		value: 'chrome',
	},
	{
		label: __('Chromium', 'betterlinks-pro'),
		value: 'chromium',
	},
	{
		label: __('Firefox', 'betterlinks-pro'),
		value: 'firefox',
	},
	{
		label: __('Kindle', 'betterlinks-pro'),
		value: 'kindle',
	},
	{
		label: __('Opera', 'betterlinks-pro'),
		value: 'opera',
	},
	{
		label: __('Opera Coast', 'betterlinks-pro'),
		value: 'operacoast',
	},
	{
		label: __('Safari', 'betterlinks-pro'),
		value: 'safari',
	},
	{
		label: __('Edge', 'betterlinks-pro'),
		value: 'edge',
	},
];

export default function Technology(props) {
	const { value, extra, setFieldValue, target_url } = props;

	return (
		<React.Fragment>
			<div className="btl-modal-form-group">
				<label className="btl-modal-form-label" style={{ paddingBottom: 0 }}>
					{__('Device Based Target URLs', 'betterlinks-pro')}
				</label>
			</div>
			<div>
				{value.length > 0 &&
					value.map((item, index) => (
						<div className="btl-modal-form-group btl-bg-gray-light">
							<div className="btl-modal-form-label btl-small-label">
								{__('Target URL', 'betterlinks-pro')} {index + 1}
							</div>
							<div className="btl-modal-technology-redirect-content">
								<div className="btl-time-technology-selector-wrapper">
									<Select
										openOnFocus={true}
										className="btl-modal-select--full"
										classNamePrefix="btl-react-select"
										defaultValue={deviceList.filter((device, index) => device.value == item.device)}
										onChange={(link) => setFieldValue(`dynamic_redirect.value.${index}.device`, link.value)}
										options={deviceList}
										placeholder={__('Device', 'betterlinks-pro')}
										isSearchable={false}
									/>
									<Select
										openOnFocus={true}
										className="btl-modal-select--full"
										classNamePrefix="btl-react-select"
										defaultValue={osList.filter((os, index) => os.value == item.os)}
										onChange={(link) => setFieldValue(`dynamic_redirect.value.${index}.os`, link.value)}
										options={osList}
										placeholder={__('Operating System', 'betterlinks-pro')}
										isSearchable={false}
									/>
									<Select
										openOnFocus={true}
										className="btl-modal-select--full"
										classNamePrefix="btl-react-select"
										defaultValue={browserList.filter((browser, index) => browser.value == item.browser)}
										onChange={(link) => setFieldValue(`dynamic_redirect.value.${index}.browser`, link.value)}
										options={browserList}
										placeholder={__('Browser', 'betterlinks-pro')}
										isSearchable={false}
									/>
								</div>
								<div className="btl-url-selector-wrapper">
									<label className="btl-modal-url-select">
										<input
											className="btl-modal-form-control"
											type="text"
											placeholder={__('Target URL', 'betterlinks-pro')}
											value={item.link}
											onChange={(e) => setFieldValue(`dynamic_redirect.value.${index}.link`, e.target.value.replace(/\s+/g, ''))}
										/>
									</label>
									<button
										type="button"
										className="btl-delete-button"
										onClick={() =>
											setFieldValue(
												'dynamic_redirect.value',
												value.filter((item, itemIndex) => itemIndex != index)
											)
										}
									>
										<span className="dashicons dashicons-trash"></span>
									</button>
								</div>
							</div>
						</div>
					))}
				<div className="btl-modal-form-group">
					<div className="btl-modal-form-label btl-small-label"></div>
					<button className="btl-add-link-button" type="button" onClick={() => setFieldValue('dynamic_redirect.value', [...value, { country: '', link: '' }])}>
						<span className="icon">
							<span className="btl btl-add"></span>
						</span>
						<span className="text">{__('Add New Link', 'betterlinks-pro')}</span>
					</button>
				</div>
			</div>
		</React.Fragment>
	);
}

Technology.propTypes = propTypes;
Technology.defaultProps = defaultProps;
