import React from 'react';
import { __ } from '@wordpress/i18n';
import DateFnsUtils from '@date-io/date-fns';
import { DateTimePicker, MuiPickersUtilsProvider } from '@material-ui/pickers';
import PropTypes from 'prop-types';

const propTypes = {};

const defaultProps = {};

export default function Time(props) {
	const { value, setFieldValue } = props;

	return (
		<React.Fragment>
			<div className="btl-modal-form-group">
				<label className="btl-modal-form-label" style={{ paddingBottom: 0 }}>
					{__('Time Based Target URLs', 'betterlinks-pro')}
				</label>
			</div>
			<div>
				{value.length > 0 &&
					value.map((item, index) => (
						<div className="btl-modal-form-group btl-bg-gray-light">
							<div className="btl-modal-form-label btl-small-label">
								{__('Target URL', 'betterlinks-pro')} {index + 1}
							</div>
							<div className="btl-modal-form-time-redirect-content">
								<div className="btl-time-date-picker-wrapper">
									<label className="btl-time-date-picker">
										{__('Start Date', 'betterlinks-pro')}
										<MuiPickersUtilsProvider utils={DateFnsUtils}>
											<DateTimePicker
												clearable
												disablePast={true}
												label="DateTimePicker"
												inputVariant="outlined"
												value={item.start_date ? item.start_date : null}
												onChange={(e) => setFieldValue(`dynamic_redirect.value.${index}.start_date`, e)}
											/>
										</MuiPickersUtilsProvider>
									</label>
									<label className="btl-time-date-picker">
										{__('End Date', 'betterlinks-pro')}
										<MuiPickersUtilsProvider utils={DateFnsUtils}>
											<DateTimePicker
												clearable
												disablePast={true}
												label="DateTimePicker"
												inputVariant="outlined"
												value={item.end_date ? item.end_date : null}
												onChange={(e) => setFieldValue(`dynamic_redirect.value.${index}.end_date`, e)}
											/>
										</MuiPickersUtilsProvider>
									</label>
								</div>
								<div className="btl-url-selector-wrapper">
									<label className="btl-modal-url-select">
										<input
											className="btl-modal-form-control"
											type="text"
											placeholder={__('Target URL', 'betterlinks-pro')}
											value={item.link}
											onChange={(e) => setFieldValue(`dynamic_redirect.value.${index}.link`, e.target.value.replace(/\s+/g, ''))}
										/>
									</label>
									<button
										type="button"
										className="btl-delete-button"
										onClick={() =>
											setFieldValue(
												'dynamic_redirect.value',
												value.filter((item, itemIndex) => itemIndex != index)
											)
										}
									>
										<span className="dashicons dashicons-trash"></span>
									</button>
								</div>
							</div>
						</div>
					))}
				<div className="btl-modal-form-group">
					<div className="btl-modal-form-label btl-small-label"></div>
					<button className="btl-add-link-button" type="button" onClick={() => setFieldValue('dynamic_redirect.value', [...value, { country: '', link: '' }])}>
						<span className="icon">
							<span className="btl btl-add"></span>
						</span>
						<span className="text">{__('Add New Link', 'betterlinks-pro')}</span>
					</button>
				</div>
			</div>
		</React.Fragment>
	);
}

Time.propTypes = propTypes;
Time.defaultProps = defaultProps;
